<?php
namespace PACKS\SHIPMENTS\Admin;
use PACKS\SHIPMENTS\Admin\AdminNotice;
use PACKS\SHIPMENTS\Admin\Getproductinfo;
use PACKS\SHIPMENTS\Settings;

if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

if ( !class_exists( '\\PACKS\\SHIPMENTS\\Admin\\Exportshipments' ) ) :



class Exportshipments
{
    protected $apiUser;
    protected $apiUserPassword;
    protected $apiUrl;
    protected $apiAuthUrl;
    protected $orderIds;
    protected $shipments;
    protected $postData;
    protected $_shipmentsData;
    protected $aToken;
    protected $tToken;
    protected $continue;
    protected $orders = array();
    public $responses = array();
    protected $responseMessages = array();
    protected $productoptions;
    protected $settings;

    public function __construct($orderIds)
    {
        $this->Getproductinfo = new Getproductinfo();
        if($this->Getproductinfo && $this->Getproductinfo->continue == true){
            $this->productoptions = $this->Getproductinfo->responses['products'];
        }else{
            return;
        }
        $this->settings = new Settings();
        $this->orderIds = $orderIds;
        $this->custom();
        if(isset($_POST['order_ids'])){
            $this->postData = $_POST;
        }
    }

    public function custom()
    {

        include('views/packs-createshipments-page.php');

        if(isset($_POST['order_ids'])){
            $this->postData = $_POST;
            $this->preprocessData($this->postData);


                $this->responseHandler();

        }
    }

    public function preprocessData($data)
    {
        $this->senderOptions = get_option('packs_shipments_settings_sender');
        $this->generalOptions = $this->settings->get_common_general_settings();
        $this->apiUser = $this->generalOptions['api_user_name']['default'];
        $this->apiUserPassword = $this->generalOptions['api_user_password']['default'];
        $this->apiUrl = $this->generalOptions['api_url'];
        $this->apiAuthUrl = $this->generalOptions['api_auth_url'];

        set_time_limit(720000);                 // script timeout: 15 mins.
        ob_start();

        $this->Authorize();
        $this->processData($this->postData);
    }

    public function Authorize()
    {
            $postString = "client_id=PacksOnlineApp&client_secret=secret&grant_type=password&scope=PacksOnlineAPI&username=".$this->apiUser."&password=".$this->apiUserPassword;

            // PHP cURL  for https connection with auth
            $ch = curl_init();
            curl_setopt_array($ch, array(
                CURLOPT_URL => "".$this->apiAuthUrl."",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => "".$postString."",
                CURLOPT_HTTPHEADER => array(
                    "Cache-Control: no-cache",
                    "Content-Type: application/x-www-form-urlencoded",
                ),
                CURLOPT_SSL_VERIFYPEER => false,
            ));

            $result = curl_exec($ch);

            $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
            curl_close($ch);
            unset($ch);

            $json = json_decode($result);
            $this->tToken = $json->token_type;
            $this->aToken = $json->access_token;


        return;
    }

    public function processData($data)
    {
        $senderData = $this->getSenderData();
        $orders = $this->getWooOrderdata($this->orderIds);

        foreach($orders as $order){
            if(isset($order['shipping']['company'][0])){
                $shipping_name = $order['shipping']['company'];
            }else{
                $shipping_name = $order['shipping']['first_name'].' ' . $order['shipping']['last_name'];
                $company = false;
            }

            try {
                // xml post structure
                $xml_post_array = array(
                    'handler'=> $senderData['handler'],
                    'network'=> $senderData['network'],
                    'loadDate'=> $this->getLoadDate($order),
                    'deliveryDate'=> $this->getDeliveryDate($order),
                    'loadAddress'=> array(
                        'country'=> $senderData['country'],
                        'name'=> $senderData['company'],
                        'nameTo'=>$senderData['name'],
                        'street'=> $senderData['street'],
                        'number'=> $senderData['housenumber'],
                        'numberExt'=> $senderData['numberext'],
                        'location'=> '',
                        'zip'=> $senderData['postcode'],
                        'place'=> $senderData['city'],
                        'reference'=> $senderData['reference'],
                        'mail' => $senderData['mail']
                    ),
                    'deliveryAddress'=> array(
                        'country'=> $order['shipping']['country'],
                        'name'=> $shipping_name,
                        'nameTo'=>$order['shipping']['first_name'].' ' . $order['shipping']['last_name'],
                        'street'=> $this->splitAddress($order['shipping']['address_1'])[0],
                        'number'=> $this->splitAddress($order['shipping']['address_1'])[1],
                        'numberExt'=> $order['shipping']['address_2'],
                        'zip'=> $order['shipping']['postcode'],
                        'place'=> $order['shipping']['city'],
                        'reference'=> $this->getReferentie($order),
                        'mail' => $order['billing']['email'],
                        'phone' => $order['billing']['phone']
                    ),
                    'surcharges'=> array(),
                    'shipmentItems' => $this->getShipmentItems($order),
                );
                if($xml_post_array['deliveryAddress']['name'] == $xml_post_array['deliveryAddress']['nameTo']){
                    unset($xml_post_array['deliveryAddress']['nameTo']);
                }

                $xml_post_string = json_encode($xml_post_array);


                // PHP cURL  for https connection with auth
                $ch = curl_init();

                curl_setopt_array($ch, array(
                    CURLOPT_URL => "".$this->apiUrl."",
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => "",
                    CURLOPT_MAXREDIRS => 10,
                    CURLOPT_TIMEOUT => 30,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => "POST",
                    CURLOPT_POSTFIELDS => "".$xml_post_string."",
                    CURLOPT_HTTPHEADER => array(
                        "Accept: application/json",
                        "Authorization: ".$this->tToken." ".$this->aToken,
                        "Content-Type: application/json",
                        "cache-control: no-cache",
                    ),
                    CURLOPT_SSL_VERIFYPEER => false,

                ));

                $response = curl_exec($ch);


                if(empty($response)){
                    $response = curl_error($ch);
                    $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                    curl_close($ch);
                    unset($ch);
                    $this->continue = false;
                    AdminNotice::create()
                        ->error('Api response is empty')
                        ->show();

                }else{

                    $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                    if($httpCode == 404) {
                        $message = "HTTP Error 404. The requested resource is not found. URL";
                        $this->responseMessages['errors'][$order['id']] = $message;
                        return;
                    }
                    if($httpCode == 400) {
                        $message = $response;
                        $this->responseMessages['errors'][$order['id']] = $message;
                        $this->continue = false;
                        return;
                    }
                    if($httpCode == 503) {
                        $message = "HTTP Error 503. The api server is not available";
                        $this->responseMessages['errors'][$order['id']] = $message;
                        $this->continue = false;
                        return;
                    }
                    if (curl_errno($ch)) {
                        $err = curl_error($ch);
                        curl_close($ch);

                        $message = $err;
                        $this->responseMessages['errors'][$order['id']] = $message;

                    }

                    $jsonDecoded = json_decode($response,true);
                    curl_close($ch);
                    unset($ch);

                    $responseArray[$order['id']] = $jsonDecoded;
                    $responseArray[$order['id']] = $this->array_push_assoc($responseArray[$order['id']], 'orderId', $order['id']);
                    $this->responses[$order['id']] = $responseArray[$order['id']];
                }



            }catch (Exception $e) {
                return false;
            }
        }


    }

    public function array_push_assoc($array, $key, $value){
        $array[$key] = $value;
        return $array;
    }

    public function responseHandler(){
        foreach($this->responseMessages as $type => $responses){
            if($type == 'errors'){
                foreach($responses as $incrementId => $message){
                    AdminNotice::create()
                        ->error($message)
                        ->show();
                    unset($this->responseMessages['errors'][$incrementId]);
                }
            }
            if(!array_key_exists('success',$this->responseMessages)){
                $this->continue = false;

            }
        }
        return;
    }



    public function getWooOrderdata($orderids)
    {
        $orderids = explode(',',$orderids);
        foreach ($orderids as $orderid){
            $order = wc_get_order( $orderid );
            $order_data = $order->get_data();
            $this->orders[] = $order_data;
        }
        return $this->orders;

    }

    public function getShipmentItems($order){
        $shipmentItems = array();
        $colliQty = $this->getCollie($order);

        for($i=0; $i<$colliQty; $i++){
            $surcharge = $this->getShipmentItemSurcharges($order);
            if($surcharge){
                $shipmentItem = array(
                    'product' => $this->getSeal($order),
                    'weight' => $this->getTotalWeight($order,$colliQty),
                    'length'=> 1,
                    'height'=> 1,
                    'width'=> 1,
                    'labelText'=> 'collo'.$i,
                    'surcharges'=> array($surcharge)
                );
            }else{
                $shipmentItem = array(
                    'product' => $this->getSeal($order),
                    'weight' => $this->getTotalWeight($order,$colliQty),
                    'length'=> 1,
                    'height'=> 1,
                    'width'=> 1,
                    'labelText'=> 'collo'.$i,
                );
            }
            array_push($shipmentItems,$shipmentItem);
        }

        return $shipmentItems;
    }

    private function getShipmentItemSurcharges($order){
        if($this->getAllowance($order)) {
            $surcharge = array('surcharge'=> (string)$this->getAllowance($order));
        }else{
            $surcharge = array();
        }
        return $surcharge;
    }

    public function getSenderData(){
        $senderData = array();
        $senderData['handler'] = $this->senderOptions['sender_handler']['default'];
        $senderData['network'] = $this->senderOptions['sender_network']['default'];
        $senderData['country'] = $this->senderOptions['sender_country']['default'];
        $senderData['city'] = $this->senderOptions['sender_city']['default'];
        $senderData['postcode'] = $this->senderOptions['sender_zipcode']['default'];
        $senderData['street'] = $this->senderOptions['sender_street']['default'];
        $senderData['housenumber'] = $this->senderOptions['sender_housenumber']['default'];
        $senderData['numberext'] = $this->senderOptions['sender_numberext']['default'];
        $senderData['name'] = $this->senderOptions['sender_name']['default'];
        $senderData['company'] = $this->senderOptions['sender_company']['default'];
        $senderData['mail'] = $this->senderOptions['sender_mail']['default'];
        $senderData['reference'] = $this->senderOptions['sender_reference']['default'];

        return $senderData;
    }

    public function getSeal($order){
        $seal = $this->postData[$order['id'].'-seal'];
        return $seal;
    }

    public function getLoadDate($order){
        $loadDate = $this->postData[$order['id'].'-loaddate'];
        return $loadDate;
    }

    public function getDeliveryDate($order){
        $deliveryDate = $this->postData[$order['id'].'-deliverydate'];
        return $deliveryDate;

    }

    public function getReferentie($order){
        $reference = $this->postData[$order['id'].'-reference'];
        return $reference;
    }

    public function getCollie($order){
        $collie = $this->postData[$order['id'].'-collie'];
        return $collie;
    }

    public function getTotalWeight($order,$colliQty){
        $weight = (float)$this->postData[$order['id'].'-weight']/(float)$colliQty;
        return $weight;
    }

    public function getAllowance($order){
        if(isset($htis->postData[$order['id'].'-allowance'])){
            $allowance = $this->postData[$order['id'].'-allowance'];
            return $allowance;
        }else{
            return false;
        }
    }

    public function splitAddress($address) {
        // Get everything up to the first number with a regex
        $hasMatch = preg_match('/^[^0-9]*/', $address, $match);
        // If no matching is possible, return the supplied string as the street
        if (!$hasMatch) {
            return array($address, "", "");
        }
        // Remove the street from the address.
        $address = str_replace($match[0], "", $address);
        $street = trim($match[0]);
        // Nothing left to split, return
        if (strlen($address == 0)) {
            return array($street, "", "");
        }
        // Explode address to an array
        $addrArray = explode(" ", $address);
        // Shift the first element off the array, that is the house number
        $housenumber = array_shift($addrArray);
        // If the array is empty now, there is no extension.
        if (count($addrArray) == 0) {
            return array($street, $housenumber, "");
        }
        // Join together the remaining pieces as the extension.
        $extension = implode(" ", $addrArray);
        return array($street, $housenumber, $extension);
    }
}

endif;

